;============================================================================
; 				-1  PIC 16F873
;============================================================================
;-------------------------------------------------------------------
;0 -     (  ,  -> )
;5 -  
;0 - 
;B1 - G
;B2 - C
;B2 - H
;B4 - D
;B5 - E
;B6 - F
;B7 - A
;C4 - 3
;C5 - 2
;C6 - 1
;C7 - 4 -      .
;    ,    - p-n-p - 0,  
		LIST p=16F873			;  
		RADIX HEX			;   
		INCLUDE "P16F873.INC"		;    
		__CONFIG b'11111101110101'
;    		= 11
;   		= 1
;  10 					= 1
;    			= 1
; CPD -     .		= 1
; LVP -   .	= 0
; BODEN -    U . .	= 1
;    		= 11
; PWRTE -    .	= 0
; WDTE -    		= 1
;  - 				= 01
;============================================================================
	ORG	0x00			;  
	CBLOCK	20H			;   
		HL1			; ,  
		HL2			; 
		HL3			; 
		HL4			; 
		HLD			;   
		W_TEMP			;   
		STATUS_TEMP		;   
	ENDC				;   
		GOTO	SETUP		;    
	ORG	0x04
;============================================================================
;	      0
;============================================================================
int_handler0	;  
		MOVWF	W_TEMP      	;     W
		MOVF	STATUS,W        ;     STATUS   W
		MOVWF	STATUS_TEMP	;     STATUS
		MOVLW	0x80		;     ,   
		MOVWF	TMR0		;   
		BCF	INTCON,2	;   
		MOVLW	0xFF		; 
		MOVWF	PORTC		; 
		BTFSS	HLD,4		; ,
		MOVFW	HL3		;  
		BTFSS	HLD,5		;  
		MOVFW	HL2		;  
		BTFSS	HLD,6		;  
		MOVFW	HL1		;  
		BTFSS	HLD,7		; 
		MOVFW	HL4		; 
		MOVWF	PORTB		; 
		BTFSS	HLD,5		;   
		BCF	PORTB,3		;   
		MOVFW	HLD		;  
		MOVWF	PORTC		;      -  
		RLF	HLD,F		;   
		SKPNC			; ,  ?
		GOTO	EX_INT		;    ,   
		MOVLW	0xF7		;  
		MOVWF	HLD		;   
EX_INT		MOVF	STATUS_TEMP,W  	;     STATUS
		MOVWF	STATUS          ;    STATUS,    
		SWAPF	W_TEMP,F	;      
		SWAPF	W_TEMP,W       	;    W,    
		CLRWDT			;   
		RETFIE			;   
		

;============================================================================
;   
;============================================================================	
SETUP		
		CLRF	PORTA		;  ,    
		CLRF	PORTB		;  ,    
		CLRF	PORTC		;  ,    C
		MOVLW	0x9F		;    ADCON1
		MOVWF	FSR		;  
		MOVLW	0X0F		;  
		MOVWF	INDF		;   : 0 - ,A2 +, A3 -,   - ,   
		MOVLW	0x01		;    
		MOVWF	ADCON0		;  ,  0, Fosc/8  4 
		MOVLW	0x85		;     TRISA
		MOVWF	FSR		;   TRISA
		MOVLW	0x3F		;    
		MOVWF	INDF		;     - 
		MOVLW	0X86		;     TRISB
		MOVWF	FSR		;   TRISB
		MOVLW	0X00		;     
		MOVWF	INDF		;    - 
		MOVLW	0X87		;     TRISC
		MOVWF	FSR		;   TRISC
		CLRF	INDF		;   C - 		
		MOVLW	0X81		;   OPTION
		MOVWF	FSR		;   
		MOVLW	0XCF		;  "1101111"   OPTION
		MOVWF	INDF		; PUL_UP=Off,   WDT = 1:128
		MOVLW	0X8C		;    PIE1
		MOVWF	FSR		;  
		BSF	INDF,TMR1IE	;     1
		CLRF	RCSTA		;   USART
		CLRF	T2CON		;   TMR2
		CLRF	CCP1CON		;   CCP
		MOVLW	0XA0		;   B'10100000'  INTCON:   ,
		MOVWF	INTCON		;    :   TM0
		MOVLW	B'11101111'	;   
		MOVWF	HLD		;  0,   4  7
		
;============================================================================
;			   
;============================================================================		
START
PREOBR		BTFSS	HLD,3		;   
		GOTO	DALEE		;  
		GOTO	START
DALEE		BCF	INTCON,GIE	;  ,   
		BSF	ADCON0,2	;   
		BTFSC	ADCON0,2	; ,  
		GOTO	$-1		;  , 		
;============================================================================
;		 HEX-DEC(4)
;============================================================================
HEX_DEC		
		CLRF	HL1		; 
		CLRF	HL2		; 
		CLRF	HL3		;  
		CLRF	HL4		;   
B_1000		MOVFW	ADRESH		;  
		SUBLW	0x7E		; 1000 d  3 
		SKPNC			;  :  11  
		GOTO	M_1000		;   
		MOVLW	0x7D		;  1000,  3  
		SUBWF	ADRESH,F	;    1000
		INCF	HL1,F		; HL1+1
		GOTO	B_1000		;   1000
M_1000		BSF	STATUS,RP0	; 
		RLF	ADRESL,F	;     
		BCF	STATUS,RP0	;  
		RLF	ADRESH,F	;    2
B_100		MOVFW	ADRESH		; 999 d , 2
		SUBLW	0x1A		; -100d ot H
		SKPNC			;  
		GOTO	M_100		; 
		MOVLW	0x19		;  
		SUBWF	ADRESH,F	;    
		INCF	HL2,F		; HL2+1
		GOTO	B_100		;   100
M_100		BSF	STATUS,RP0	; 
		RLF	ADRESL,F	; 
		BCF	STATUS,RP0	;  
		RLF	ADRESH,F	;  
		BSF	STATUS,RP0	; 11
		RLF	ADRESL,F	;  
		BCF	STATUS,RP0	; 
		RLF	ADRESH,F	;   
		MOVLW	0X02		;  2
		SUBWF	ADRESH,F	;    ???
B_10		MOVFW	ADRESH		; 
		SUBLW	0x0B		; 10 d
		SKPNC			; 
		GOTO	M_10		;  
		MOVLW	0x0A		; 
		SUBWF	ADRESH,F	;  
		INCF	HL3,F		; HL1+1
		GOTO	B_10		;  
M_10		MOVFW	ADRESH		; 
		MOVWF	HL4		; 
		MOVFW	HL1		; 
		CALL	DESH_ZN		; 
		MOVWF	HL1		; 
		MOVFW	HL2		; 
		CALL	DESH_ZN		; 
		MOVWF	HL2		; 
		MOVFW	HL3		; 4  
		CALL	DESH_ZN		; 
		MOVWF	HL3		; 
		MOVFW	HL4		;  
		CALL	DESH_ZN		; EXEL
		MOVWF	HL4		;  
		BSF	STATUS,C	;  
		RLF	HLD,F		; 
		BSF	INTCON,GIE	;  
		GOTO	START		; !

;============================================================================
;		 
;============================================================================
DESH_ZN		ADDWF	PCL,F
		RETLW	0X0A		; 0,1,2,3,4,5,6,7,8,9,0
		RETLW	0XFA
		RETLW	0X4C
		RETLW	0X68
		RETLW	0XB8
		RETLW	0X29
		RETLW	0X09
		RETLW	0X7A
		RETLW	0X08
		RETLW	0X28
		RETLW	0X0A		;     10???
	End	

